import { ButtonView } from "ckeditor5/src/ui";

export default function CantoConnectRender(editor) {
  var insertContent;
  var cantoConnectorSaveCallback = function(data) {
    insertContent(data);
  };

  editor.ui.componentFactory.add('connector_canto', (locale) => {
    const button = new ButtonView(locale);
    const t = editor.t;
    button.set({
      label: t('Canto Connector'),
      icon: `<svg version="1.1" xmlns="http://www.w3.org/2000/svg" width="16" height="16">
      <path d="M0 0 C5.28 0 10.56 0 16 0 C16 5.28 16 10.56 16 16 C10.72 16 5.44 16 0 16 C0 10.72 0 5.44 0 0 Z " fill="#F58C20" transform="translate(0,0)"/>
      <path d="M0 0 C0 1.32 0 2.64 0 4 C0.185625 5.216875 0.37125 6.43375 0.5625 7.6875 C0.706875 8.780625 0.85125 9.87375 1 11 C0 12 0 12 -2.8125 12.3125 C-6 12 -6 12 -8.4375 10.375 C-10 8 -10 8 -9.9375 4.875 C-8.20208343 -0.44694415 -4.97826153 -0.22125607 0 0 Z " fill="#FCDDBD" transform="translate(12,2)"/>
      <path d="M0 0 C0.33 0.99 0.66 1.98 1 3 C-1.31 3.33 -3.62 3.66 -6 4 C-6.33 5.32 -6.66 6.64 -7 8 C-7.66 6.02 -8.32 4.04 -9 2 C-5.5647952 -0.29013653 -4.014669 -0.17842973 0 0 Z " fill="#F8B470" transform="translate(12,2)"/>
      <path d="M0 0 C-0.33 1.65 -0.66 3.3 -1 5 C-2.65 4.67 -4.3 4.34 -6 4 C-6 2.68 -6 1.36 -6 0 C-3.50907189 -1.24546405 -2.58919267 -0.7767578 0 0 Z " fill="#FEFAF6" transform="translate(12,6)"/>
      <path d="M0 0 C1.98 0 3.96 0 6 0 C6.33 0.99 6.66 1.98 7 3 C4.69 2.67 2.38 2.34 0 2 C0 1.34 0 0.68 0 0 Z " fill="#FEFAF6" transform="translate(6,2)"/>
      <path d="M0 0 C-0.33 0.99 -0.66 1.98 -1 3 C-2.65 3 -4.3 3 -6 3 C-6 2.34 -6 1.68 -6 1 C-3.92446352 0.4465236 -2.15634036 0 0 0 Z " fill="#FEFAF6" transform="translate(13,11)"/>
      </svg>`,
      tooltip: true,
      withText:false
    })
    console.log("button", button);
    button.on('execute', () => {
      var existingValues = {
        'data-align': ''
      };

      const selection = editor.model.document.selection;
      const ranges = selection.getRanges();

      if (ranges.length > 0) {
          const selectedRange = ranges[0];
          var edit_content = selectedRange.start.nodeAfter;
          console.log(edit_content);
          if (edit_content && edit_content.getAttribute('class') == 'display_image') {
            var imageData = edit_content.data('img-popup');
            imageData = imageData.split(':');
            existingValues = {
              'data-entity-uuid': imageData[0],
              'src': edit_content.getAttribute('src'),
              'alt': imageData[1],
              'image_style': imageData[2],
              'image_style_popup': imageData[3],
              'data-align': imageData[4]
            };
          }
      }
      Drupal.ckeditor5.openDialog(Drupal.url('connector_canto/dialog/image'), cantoConnectorSaveCallback, {},existingValues);
    })
    insertContent = function(html) {
      editor.model.change( writer => {
        const viewFragment = editor.data.processor.toView( html );
        const modelFragment = editor.data.toModel( viewFragment );
        editor.model.insertContent( modelFragment );
      } );
    }
    return button;
  } );

  }
