<?php

namespace Drupal\connector_canto\Controller;
use Drupal\user\Entity\User;
use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Render\RendererInterface;
use Drupal\connector_canto\CantoConnectorRepository;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

class CantoConnectorOAuthController extends ControllerBase {


    protected $repository;
    public function __construct(CantoConnectorRepository $repository) {
        $this->repository = $repository;
    }

    public static function create(ContainerInterface $container) {
        return new static(
            $container->get('connector_canto.repository') ,
            $container->get('string_translation'));
    }


    public function saveAccessToken(Request $request) {
        \Drupal::logger('connector_canto')->notice('saveAccessToken');
        //  $user =  \Drupal\user\Entity\User::load(\Drupal::currentUser()->id());
        $user =  User::load(\Drupal::currentUser()->id());
        $userId= $user->get('uid')->value;
        $env=$this->config('connector_canto.settings')->get('env');

        $entry = [
            'accessToken' => $request->request->get('accessToken'),
            'tokenType' => $request->request->get('tokenType'),
            'subdomain'=>$request->request->get('subdomain'),
            'uid'=>$userId,
            'env'=> is_null($env)?"canto.com":$env
        ];


        $return_value = $this->repository->insert($entry);

        return new JsonResponse($return_value);
    }


    public function deleteAccessToken(Request $request) {
        \Drupal::logger('connector_canto')->notice('deleteAccessToken');
        // $user =  \Drupal\user\Entity\User::load(\Drupal::currentUser()->id());
        $user =  User::load(\Drupal::currentUser()->id());
        $userId= $user->get('uid')->value;
        $entry = [
            'accessToken' => $request->request->get('accessToken'),
            'uid'=>$userId,
            'env'=>$request->request->get('env')
        ];
        \Drupal::logger('connector_canto')->notice('delete AccessToken'.$request->request->get('accessToken'));
        \Drupal::logger('connector_canto')->notice('env'.$request->request->get('env'));
/*         $env=$request->request->get('env');
        $accessToken=$request->request->get('accessToken');

        $database = \Drupal::database(); */
        $return_value = $this->repository->delete($entry);

        return new JsonResponse($return_value);

    }



}

