<?php

namespace Drupal\connector_canto\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

class CantoConnectorAdminSettingsForm extends ConfigFormBase {


    public function getFormId() {
        return 'connector_canto_admin_settings';
    }

    protected function getEditableConfigNames() {
        return [
            'connector_canto.settings',
        ];
    }

    public function buildForm(array $form, FormStateInterface $form_state) {
        $config = $this->config('connector_canto.settings');

        $form['env'] = [
            '#type' => 'select',
            '#title' => $this->t('Canto Environment selection'),
            '#options' => [
                'canto.com' => $this->t('canto.com'),
                'canto.global' => $this->t('canto.global'),
//                'staging.cantoflight.com' => $this->t('staging'),
//                'flightbycanto.com' => $this->t('dev'),
                'canto.de' => $this->t('canto.de'),
                'ca.canto.com' => $this->t('ca.canto.com'),
                'au.canto.com' => $this->t('au.canto.com'),
//                'cantodemo.com' => $this->t('cantodemo.com'),
            ],
            '#default_value' => $config->get('env')??'canto.com',
            '#attributes' => [
                'data-editor-connector_canto-canto' => 'env',
            ],

        ];

        return parent::buildForm($form, $form_state);
    }


    public function submitForm(array &$form, FormStateInterface $form_state) {
        // Retrieve the configuration
        $this->configFactory->getEditable('connector_canto.settings')
        ->set('env', $form_state->getValue('env'))
        ->save();

        parent::submitForm($form, $form_state);
    }
}
